package com.dinoparc.api.repository;

import com.dinoparc.api.controllers.dto.EventPlayerDto;
import com.dinoparc.tables.records.PlayerStatRecord;
import kotlin.Pair;
import org.jooq.TableField;

import java.util.List;
import java.util.UUID;

import static com.dinoparc.tables.PlayerStat.PLAYER_STAT;

public interface PgPlayerStatRepository {
    public static TableField<PlayerStatRecord, Long> NB_SKIP = PLAYER_STAT.NB_SKIP;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT = PLAYER_STAT.NB_FIGHT;
    public static TableField<PlayerStatRecord, Long> NB_WON_FIGHT = PLAYER_STAT.NB_WON_FIGHT;
    public static TableField<PlayerStatRecord, Long> NB_LOST_FIGHT = PLAYER_STAT.NB_LOST_FIGHT;
    public static TableField<PlayerStatRecord, Long> NB_SHINY = PLAYER_STAT.NB_SHINY;
    public static TableField<PlayerStatRecord, Long> NB_MOVE = PLAYER_STAT.NB_MOVE;
    public static TableField<PlayerStatRecord, Long> NB_DIG = PLAYER_STAT.NB_DIG;
    public static TableField<PlayerStatRecord, Long> NB_RAID_FIGHT = PLAYER_STAT.NB_RAID_FIGHT;
    public static TableField<PlayerStatRecord, Long> NB_WISTITI_FIGHT = PLAYER_STAT.NB_WISTITI_FIGHT;
    public static TableField<PlayerStatRecord, Long> NB_DAILY_REC_MISSION = PLAYER_STAT.NB_DAILY_REC_MISSION;
    public static TableField<PlayerStatRecord, Long> NB_WEEKLY_REC_MISSION = PLAYER_STAT.NB_WEEKLY_REC_MISSION;
    public static TableField<PlayerStatRecord, Long> NB_MONTHLY_REC_MISSION = PLAYER_STAT.NB_MONTHLY_REC_MISSION;
    public static TableField<PlayerStatRecord, Long> NB_FUSION = PLAYER_STAT.NB_FUSION;
    public static TableField<PlayerStatRecord, Long> SUM_FUSION = PLAYER_STAT.SUM_FUSION;
    public static TableField<PlayerStatRecord, Long> NB_RAID_FIGHT_WON = PLAYER_STAT.NB_RAID_FIGHT_WON;
    public static TableField<PlayerStatRecord, Long> SUM_GOLD_WON = PLAYER_STAT.SUM_GOLD_WON;
    public static TableField<PlayerStatRecord, Long> NB_DINOZ_BUY = PLAYER_STAT.NB_DINOZ_BUY;
    public static TableField<PlayerStatRecord, Long> NB_BAZAR_SELL = PLAYER_STAT.NB_BAZAR_SELL;
    public static TableField<PlayerStatRecord, Long> NB_BAZAR_BUY = PLAYER_STAT.NB_BAZAR_BUY;
    public static TableField<PlayerStatRecord, Long> NB_BONS_BUY = PLAYER_STAT.NB_BONS_BUY;
    public static TableField<PlayerStatRecord, Long> NB_BONS_SELL = PLAYER_STAT.NB_BONS_SELL;
    public static TableField<PlayerStatRecord, Long> NB_EGG_HATCH = PLAYER_STAT.NB_EGG_HATCH;
    public static TableField<PlayerStatRecord, Long> NB_WISTITI_SKIP = PLAYER_STAT.NB_WISTITI_SKIP;
    public static TableField<PlayerStatRecord, Long> SUM_GOLD_SHOPS = PLAYER_STAT.SUM_GOLD_SHOPS;
    public static TableField<PlayerStatRecord, Long> NB_POISON_INFECTION = PLAYER_STAT.NB_POISON_INFECTION;
    public static TableField<PlayerStatRecord, Long> NB_CHIKABUM_INFECTION = PLAYER_STAT.NB_CHIKABUM_INFECTION;
    public static TableField<PlayerStatRecord, Long> NB_DARK_DINOZ = PLAYER_STAT.NB_DARK_DINOZ;
    public static TableField<PlayerStatRecord, Long> NB_KO = PLAYER_STAT.NB_KO;
    public static TableField<PlayerStatRecord, Integer> EVENT_COUNTER = PLAYER_STAT.EVENT_COUNTER;
    public static TableField<PlayerStatRecord, Long> NB_DAILY_RAID_FIGHT = PLAYER_STAT.NB_DAILY_RAID_FIGHT;
    public static TableField<PlayerStatRecord, Long> NB_WAR_FIGHT = PLAYER_STAT.NB_WAR_FIGHT;
    public static TableField<PlayerStatRecord, Long> NB_CHAMPIFUZ = PLAYER_STAT.NB_CHAMPIFUZ;
    public static TableField<PlayerStatRecord, Long> NB_CATAPULT = PLAYER_STAT.NB_CATAPULT;
    public static TableField<PlayerStatRecord, Long> NB_CLIMB = PLAYER_STAT.NB_CLIMB;
    public static TableField<PlayerStatRecord, Long> NB_PRUNAYER = PLAYER_STAT.NB_PRUNAYER;
    public static TableField<PlayerStatRecord, Long> NB_FISHING = PLAYER_STAT.NB_FISHING;
    public static TableField<PlayerStatRecord, Long> NB_PICKING = PLAYER_STAT.NB_PICKING;

    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_0 = PLAYER_STAT.NB_FIGHT_RACE_0;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_1 = PLAYER_STAT.NB_FIGHT_RACE_1;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_2 = PLAYER_STAT.NB_FIGHT_RACE_2;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_3 = PLAYER_STAT.NB_FIGHT_RACE_3;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_4 = PLAYER_STAT.NB_FIGHT_RACE_4;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_5 = PLAYER_STAT.NB_FIGHT_RACE_5;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_6 = PLAYER_STAT.NB_FIGHT_RACE_6;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_7 = PLAYER_STAT.NB_FIGHT_RACE_7;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_8 = PLAYER_STAT.NB_FIGHT_RACE_8;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_9 = PLAYER_STAT.NB_FIGHT_RACE_9;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_A = PLAYER_STAT.NB_FIGHT_RACE_A;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_B = PLAYER_STAT.NB_FIGHT_RACE_B;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_C = PLAYER_STAT.NB_FIGHT_RACE_C;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_D = PLAYER_STAT.NB_FIGHT_RACE_D;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_E = PLAYER_STAT.NB_FIGHT_RACE_E;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_F = PLAYER_STAT.NB_FIGHT_RACE_F;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_G = PLAYER_STAT.NB_FIGHT_RACE_G;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_H = PLAYER_STAT.NB_FIGHT_RACE_H;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_I = PLAYER_STAT.NB_FIGHT_RACE_I;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_J = PLAYER_STAT.NB_FIGHT_RACE_J;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_K = PLAYER_STAT.NB_FIGHT_RACE_K;
    public static TableField<PlayerStatRecord, Long> NB_FIGHT_RACE_L = PLAYER_STAT.NB_FIGHT_RACE_L;

    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_0 = PLAYER_STAT.NB_SHINY_RACE_0;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_1 = PLAYER_STAT.NB_SHINY_RACE_1;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_2 = PLAYER_STAT.NB_SHINY_RACE_2;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_3 = PLAYER_STAT.NB_SHINY_RACE_3;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_4 = PLAYER_STAT.NB_SHINY_RACE_4;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_5 = PLAYER_STAT.NB_SHINY_RACE_5;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_6 = PLAYER_STAT.NB_SHINY_RACE_6;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_7 = PLAYER_STAT.NB_SHINY_RACE_7;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_8 = PLAYER_STAT.NB_SHINY_RACE_8;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_9 = PLAYER_STAT.NB_SHINY_RACE_9;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_A = PLAYER_STAT.NB_SHINY_RACE_A;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_B = PLAYER_STAT.NB_SHINY_RACE_B;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_C = PLAYER_STAT.NB_SHINY_RACE_C;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_D = PLAYER_STAT.NB_SHINY_RACE_D;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_E = PLAYER_STAT.NB_SHINY_RACE_E;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_F = PLAYER_STAT.NB_SHINY_RACE_F;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_G = PLAYER_STAT.NB_SHINY_RACE_G;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_H = PLAYER_STAT.NB_SHINY_RACE_H;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_I = PLAYER_STAT.NB_SHINY_RACE_I;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_J = PLAYER_STAT.NB_SHINY_RACE_J;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_K = PLAYER_STAT.NB_SHINY_RACE_K;
    public static TableField<PlayerStatRecord, Long> NB_SHINY_RACE_L = PLAYER_STAT.NB_SHINY_RACE_L;

    void create(UUID playerId, String dinozId);
    void addStats(UUID playerId, String dinozId, List<Pair<TableField<PlayerStatRecord, Long>, Integer>> fields);
    List<EventPlayerDto> getAllActiveHalloweenEventCounters();
    Long getCounter(UUID playerId, String counterName);
    Long getCounter(UUID playerId, String dinozId, String counterName);
    void deletePlayerStats(UUID playerId);
    void deleteDinozStats(String dinozId);
    void deleteDinozStatsByPlayerId(String playerId);
    void resetAllPlayerStat(UUID playerId, TableField<PlayerStatRecord, Long> field);
    void resetAllPlayerStatForEventCounter();
}
